<!DOCTYPE html>
<%--
 Copyright (c) 2011, 2012 IBM Corporation and others.

 All rights reserved. This program and the accompanying materials
 are made available under the terms of the Eclipse Public License v1.0
 and Eclipse Distribution License v. 1.0 which accompanies this distribution.

 The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 and the Eclipse Distribution License is available at
 http://www.eclipse.org/org/documents/edl-v10.php.

 Contributors:

  Sam Padgett	  	- initial API and implementation
  Michael Fiedler	- adapted for OSLC4J
  Jad El-khoury     - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
  Frederic Loiret   - updated JSP files for generated HTML pages and generated OSLC UI Previews

 This file is generated by org.eclipse.lyo.oslc4j.codegenerator
--%>

<%@ page import="org.eclipse.lyo.oslc4j.core.model.ServiceProvider"%>
<%@ page import="org.eclipse.lyo.oslc4j.core.model.AbstractResource"%>
<%@ page import="java.util.List" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page import="se.kth.md.adaptors.basicexample.BasicAdaptorJSPHelper" %>
<%@ page import="se.kth.md.adaptors.basicexample.resources.Developer"%>
<%@ page import="se.kth.md.adaptors.basicexample.resources.ExtendedRequirement"%>
<%@ page import="se.kth.md.adaptors.basicexample.resources.SoftwareProduct"%>
<%--
Start of user code imports
--%>
<%--
End of user code
--%>

<%@ page contentType="text/html" language="java" pageEncoding="UTF-8" %>

<%
  List<AbstractResource> resources = (List<AbstractResource>) request.getAttribute("resources");
  String queryUri = (String)request.getAttribute("queryUri");
  String nextPageUri = (String)request.getAttribute("nextPageUri");
%>
<%--
Start of user code getRequestAttributes
--%>
<%--
End of user code
--%>

<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <title>Query Results</title>

  <link href="<c:url value="/import/bootstrap.min.css"/>" rel="stylesheet">
  <link href="<c:url value="/import/sticky-footer-navbar.css"/>" rel="stylesheet">
  <link href="<c:url value="/import/dijit.tundra.css"/>" rel="stylesheet">

  <!-- ======================================================================
  Dojo framework includes and requires
<link rel="stylesheet" type="text/css" href="http://ajax.googleapis.com/ajax/libs/dojo/1.10.4/dojo/resources/dojo.css">
<link rel="stylesheet" type="text/css" href="http://ajax.googleapis.com/ajax/libs/dojo/1.10.4/dijit/themes/tundra/tundra.css">
  -->
  <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/dojo/1.10.4/dojo/dojo.js" djConfig="parseOnLoad:true"></script>
  <script type="text/javascript">
      dojo.require("dojo.parser");
      dojo.require("dijit.Dialog");
      dojo.require("dijit.Tooltip");
      dojo.require("dijit.form.Button");
      dojo.require("dijit.form.Form");
      dojo.require("dijit.form.TextBox");
      dojo.require("dojo.NodeList-manipulate");
  </script>

    <%--
Start of user code (RECOMMENDED) headStuff
    --%>
    <%--
End of user code
    --%>
  </head>

<body class="tundra">

<!-- Fixed navbar -->
<nav class="navbar navbar-default navbar-fixed-top">
      <div class="container">
          <div class="navbar-header">
              <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
                  <span class="sr-only">Toggle navigation</span>
                  <span class="icon-bar"></span>
                  <span class="icon-bar"></span>
                  <span class="icon-bar"></span>
              </button>
              <a class="navbar-brand" href="<c:url value="/services/catalog/singleton"/>"><%= BasicAdaptorJSPHelper.getHTMLPageTitle() %></a>
          </div>
      </div>
</nav>

  <!-- Begin page content -->
  <div class="container">
    <div class="page-header">
      <h2>Query Results</h2>
      <h5>Number of elements:&nbsp;
        <%= resources.size()%>
      </h5>

    </div>

        <%--
Start of user code (RECOMMENDED) bodyStuff1
        --%>
        <%--
End of user code
        --%>

        <% for (AbstractResource aResource : resources) { %>
			<%--
Start of user code (RECOMMENDED) query_item
        	--%>
				<p><a href="<%= aResource.getAbout() %>"><%=aResource.getAbout().toString()%></a><br /></p>		
       		<%--
End of user code
        	--%>
        <% } %>
        <% if (nextPageUri != null) { %><a href="<%= nextPageUri %>">Next Page</a><% } %>

      </div>

  <footer class="footer">
      <div class="container">
          <p class="text-muted"><%= BasicAdaptorJSPHelper.getHTMLPageFooterLabel() %></p>
      </div>
  </footer>

<!-- ==========================================================================
Code for OSLC UI Preview
-->

<script language="JavaScript">

    dojo.addOnLoad(addPreviewMouseOverHandlers);

    function addPreviewMouseOverHandlers() {
        dojo.query("a").forEach(function(elem) {
            elem.onmouseover = function() { showPreview(elem); };
        });
    }

    /* show UI Preview for specified link element */
    function showPreview(elem) { // (1)
        var previewURI = elem.getAttribute("href"); // (2)
        if (!previewURI) return;
        dojo.xhrGet({  // (3)
            url: previewURI,
            handleAs:"xml",
            headers: {
                "Accept": "application/x-oslc-compact+xml", // (4)
            },
            load: function(data) {
                try {
                    var previewData = parsePreview(data); // (5)
                    var html = "<iframe src='" + previewData.uri + "' "; // (6)
                    var w = previewData.width ? previewData.width : "45em";
                    var h = previewData.height ? previewData.height : "11em";
                    html += " style='border:0px; height:" + h + "; width:" + w + "'";
                    html += "></iframe>";
                    var tip = new dijit.Tooltip({label: html, connectId: elem}); // (7)
                    tip.open(elem);
                } catch (e) { // (8)
                    var tip = new dijit.Tooltip({label: "Error parsing", connectId: elem});
                    tip.open(elem);
                }
            },
            error: function (error) {
                var tip = new dijit.Tooltip({label: "Preview not found", connectId: elem});
                tip.open(elem); // (10)
            }
        });
    }

    /* parse OSLC UI Preview XML into JSON structure with uri, h and w */
    function parsePreview(xml) { // (1)
        var ret = {};
        var compact = firstChild(firstChild(xml));
        var smallPrev = firstChildNamed(compact,'oslc:smallPreview'); //(2a)
        var largePrev = firstChildNamed(compact, 'oslc:largePreview'); //(2b)
        var preview;
        if(smallPrev != null){
            preview = firstChild(smallPrev);
        } else{
            preview = firstChild(largePrev);
        }
        if (preview) {
            var document = firstChildNamed(preview, 'oslc:document');
            if (document) ret.uri = document.getAttribute('rdf:resource');
            var height = firstChildNamed(preview, 'oslc:hintHeight');
            ret.height = height.textContent;
            var width = firstChildNamed(preview, 'oslc:hintWidth');
            ret.width = width.textContent;
        }
        return ret;
    }

    function firstChild(e) { // (3)
        for (i=0; i<e.childNodes.length; i++) {
            if (e.childNodes[i].nodeType == Node.ELEMENT_NODE) {
                return e.childNodes[i];
            }
        }
    }

    function firstChildNamed(e, nodeName) { // (4)
        for (i=0; i<e.childNodes.length; i++) {
            if (e.childNodes[i].nodeType == Node.ELEMENT_NODE
                && e.childNodes[i].nodeName == nodeName) {
                return e.childNodes[i];
            }
        }
    }


</script>

  <script src="<c:url value="/import/bootstrap.min.js"/>"/></script>

</body>
</html>

